﻿Type=Activity
Version=1.50
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Type Grid (  Name As String _
				,Frame As Panel _
				,Table As Panel _
				,Scroll As ScrollView _
				,btnLeft As Button _
				,btnRight As Button _
				,Header As Panel _
				,HeaderExist As Boolean _
				,Cols As Int _
				,Rows As Int _
				,ColWidth(100) As Int _
				,ColLineWidth As Int _
				,RowHeight As Int _
				,RowLineWidth As Int _
				,HeaderColor As Int _
				,LineColor As Int _
				,CellColor As Int _
				,FontSize As Float _
				,FontColor As Int _
				,HeaderFontColor As Int _
				,SelectedRowColor As Int _
				,Alignment As Int _
				,SelectedRow As Int _
				,Left As Int _
				,Top As Int _
				,Width As Int _
				,Height As Int _
				,ScrollOffset As Int _
			)
	
	
	Type RowCol (Row As Int, Col As Int)

	Dim StringUtils1, StringUtils2 As StringUtils	
	Dim Alignment As Int	
	

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

End Sub

Sub Activity_Create(FirstTime As Boolean)

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub TableCreate(grd As Grid ,Name As String,Left As Int,Top As Int,Width As Int,Height As Int,csvFile As String)
	
	grd.Initialize
	grd.Frame.Initialize("Frame")
	grd.Table.Initialize("Tables")
	grd.Scroll.Initialize(0)
	grd.btnLeft.Initialize(Name&"_btnLeft")
	grd.btnRight.Initialize(Name&"_btnRight")
	grd.btnLeft.Visible=False
	grd.btnRight.Visible=False
	grd.Scroll.Panel.Color=Colors.Black
	grd.Name = Name
	grd.Scroll.Tag=Name
	grd.Table = grd.Scroll.Panel
	grd.HeaderExist=True
	grd.ColLineWidth=1
	grd.HeaderColor = Colors.Gray
	grd.ColLineWidth = 1dip
	grd.RowHeight = 20dip
	grd.RowLineWidth = 1dip
	grd.LineColor = Colors.Black
	grd.CellColor = Colors.White
	grd.SelectedRowColor=Colors.LightGray
	grd.FontSize = 8
	grd.FontColor = Colors.Black
	grd.HeaderFontColor = Colors.White
	grd.Alignment = Gravity.CENTER 'change to Gravity.LEFT or Gravity.RIGHT for other alignments.	
	grd.Left=Left 
	grd.Top=Top
	grd.Width=Width 
	grd.Height=Height
	grd.ScrollOffset=0   'use scrolling horizontal
	'Activity.AddView(grd.Frame, grd.Left, grd.Top + grd.RowHeight, grd.Width, grd.Height-grd.RowHeight)
	grd.Frame.AddView( grd.Scroll , 0, grd.RowHeight, grd.Width, grd.Height-grd.RowHeight)

	grd.SelectedRow = -1
	if csvFile>"" Then
		LoadTableFromCSV(grd,File.DirAssets, csvFile)
	End if
	
	grd.Frame.AddView( grd.btnLeft , 0, 0, 50, grd.RowHeight)
	grd.Frame.AddView( grd.btnRight , grd.Width-50,0, 50, grd.RowHeight)

End Sub

'Clears the previous Table1 and loads the CSV file to the Table1
'tabloların ilk satırında kolon genişlikleri olsun
'ikinci satırında başlıklar olsun
'sonraki satırlarda bilgiler olacak
Sub LoadTableFromCSV(grd As Grid, Dir As String, Filename As String)
	ClearGridAll(grd)
	Dim List1 As List
	Dim h() As String

	Dim headers As List
	List1 = StringUtils1.LoadCSV2(Dir, Filename, ",",  headers)
	Dim h(headers.Size) As String
	For i = 0 To headers.Size - 1
		h(i) = headers.Get(i)
	Next

	grd.Cols = h.Length
	grd.Rows=0
	
	SetHeader(grd,h)
	For i = 0 To List1.Size - 1
		Dim row() As String
		row = List1.Get(i)
		AddRow(grd,row)
	Next	
	
End Sub

Sub SaveTableToCSV1(grd As Grid,Dir As String, Filename As String)
	Dim headers(grd.Cols) As String
	
	For i = 0 To headers.Length - 1
		Dim l As Label
		l =grd.Header.GetView(i)
		headers(i) = l.Text
	Next
	Dim list1 As List
	list1.Initialize
	For i = 0 To grd.Rows - 1
		Dim row(grd.Cols) As String
		For c = 0 To grd.Cols - 1
			row(c) = GetCell(grd,i, c)
		Next
		list1.Add(row)
	Next
	StringUtils1.SaveCSV2(Dir, Filename, ",", list1, headers)
End Sub

Sub Header_Click
	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag
	'Return  "Header1 clicked: " & col
End Sub

Sub SelectRow(grd As Grid,Row As Int)
	'remove the color of previously selected row
	If grd.SelectedRow > -1 Then
    	For col = 0 To grd.Cols - 1
			GetView(grd.Table,grd.SelectedRow, Col).Color = grd.CellColor			
		Next
	End If
	grd.SelectedRow = Row
	For col = 0 To grd.Cols - 1
		GetView(grd.Table,Row, Col).Color = grd.SelectedRowColor
	Next
End Sub


'Returns the label in the specific cell
Sub GetView(grd As Grid,Row As Int, Col As Int) As Label
	Dim l As Label
	
	l = grd.Table.GetView(Row * grd.Cols + Col)
	Return l
End Sub

'Adds a row to the Table1
Sub AddRow(grd As Grid, Values() As String)
	Dim sumWidth As Int
	If values.Length <> grd.Cols Then
		Log("Wrong number of values.")
		Return
	End If
	sumWidth=0	
	For i = 0 To grd.Cols - 1
		Dim l As Label
		l.Initialize(grd.Name & "_Cell")
		l.Text = values(i)
		l.Gravity = grd.Alignment
		l.TextSize = grd.FontSize
		l.TextColor = grd.FontColor
		l.Color=Colors.White
		Dim rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = grd.Rows
		l.Tag = rc
		grd.Table.AddView(l, sumWidth, grd.RowHeight * grd.Rows , grd.ColWidth(i)-grd.ColLineWidth ,grd.RowHeight-grd.RowLineWidth)
		sumWidth=sumWidth+grd.ColWidth(i)
	Next
	grd.Table.Width=sumWidth
	grd.Rows = grd.Rows+1
	grd.Table.Height =grd.Rows * grd.RowHeight
End Sub

'Set the headers values
Sub SetHeader(grd As Grid,Values() As String)
	Dim width As Int,sumWidth As Int
	Dim head() As String
	If grd.Header.IsInitialized Then Return 'should only be called once
	grd.Header.Initialize("")
	sumWidth=0
	For i = 0 To Values.Length-1
		Dim l As Label
		l.Initialize("Header")
		head = Regex.Split("\|",  values(i))
		l.Text= head(0)
		width = head(1)
		grd.ColWidth(i)=width
		l.Gravity = Gravity.CENTER
		l.TextSize = grd.FontSize
		l.Color = grd.HeaderColor
		l.TextColor =grd.HeaderFontColor
		l.Tag = i
		grd.Header.AddView(l,  sumWidth, 0, width - grd.ColLineWidth, grd.RowHeight - grd.RowLineWidth)
		sumWidth=sumWidth+width
	Next
	grd.Table.Width = sumWidth
	grd.Frame.AddView(grd.Header,0,0 , grd.Width, grd.RowHeight)	
End Sub

'Sets the value of the given cell
Sub SetCell(grd As Grid,Row As Int, Col As Int, Value As String)
	GetView(grd.Table,Row, Col).Text = value
End Sub

'Gets the value of the given cell
Sub GetCell(grd As Grid,Row As Int, Col As Int) As String
	Return GetView(grd.Table,Row, Col).Text
End Sub

'Clears the Table1
Sub ClearGridAll(grd As Grid)
	For i = grd.Table.NumberOfViews -1 To 0 Step -1
		grd.Table.RemoveViewAt(i)
	Next
	grd.Table.Height = 0
End Sub

Sub Table_Scroll(grd As Grid,Left As Boolean)
	if left=True Then kay=-20 Else kay=20
	grd.ScrollOffset=grd.ScrollOffset+kay
	
	grd.Scroll.Left=grd.ScrollOffset
	grd.Scroll.Width=grd.Scroll.Width-grd.ScrollOffset
	
	grd.Header.Left=grd.ScrollOffset
	grd.Header.Width=grd.Width-grd.ScrollOffset
End Sub