﻿Type=StaticCode
Version=1.50
@EndOfDesignText@
'do not change this module
Sub Process_Globals

	Type Grid (  Name As String _
				,Frame As Panel _
				,Table As Panel _
				,Scroll As ScrollView _
				,btnLeft As Button _
				,btnRight As Button _
				,tmrScrollButtonOff As Timer _
				,Header As Panel _
				,HeaderExist As Boolean _
				,txtEdit As EditText _
				,colProp(100) As Columns _
				,Cols As Int _
				,Rows As Int _
				,Col As Int _
				,Row As Int _
				,ColLineWidth As Int _
				,RowHeight As Int _
				,RowLineWidth As Int _
				,HeaderColor As Int _
				,LineColor As Int _
				,CellColor As Int _
				,FontSize As Float _
				,FontColor As Int _
				,HeaderFontColor As Int _
				,SelectedRowColor As Int _
				,Alignment As Int _
				,SelectedRow As Int _
				,Left As Int _
				,Top As Int _
				,Width As Int _
				,Height As Int _
				,ScrollOffset As Int _
			)
		
	'Cells row,col and key data
	Type RowCol ( Row As Int,Col As Int,Key As Int)

	Dim StringUtils1 As StringUtils		
	Dim btnLeftImage,btnRightImage As Bitmap

End Sub


Sub TableCreate(grd As Grid ,Name As String,Left As Int,Top As Int,Width As Int,Height As Int,fontSize As Int,rowHeight As Int,csvFile As String)
	
	grd.Initialize
	grd.Frame.Initialize("Frame")
	grd.Table.Initialize("Tables")
	grd.Scroll.Initialize(0)

	grd.btnLeft.Initialize(Name & "_btnLeft")
	grd.btnRight.Initialize(Name & "_btnRight")

	grd.btnLeft.Visible=False
	grd.btnRight.Visible=False
	grd.tmrScrollButtonOff.Initialize(Name & "_tmrScrollButtonOff",5000)
	
	grd.Scroll.Panel.Color=Colors.Black
	grd.Name = Name
	grd.Scroll.Tag=Name
	grd.Table = grd.Scroll.Panel
	grd.HeaderExist=True
	grd.ColLineWidth=1
	grd.HeaderColor = Colors.Gray
	grd.ColLineWidth = 1dip
	grd.RowHeight = rowHeight
	grd.RowLineWidth = 1dip
	grd.LineColor = Colors.Black
	grd.CellColor = Colors.White
	grd.SelectedRowColor=Colors.LightGray
	grd.FontSize =fontSize
	grd.FontColor = Colors.Black
	grd.HeaderFontColor = Colors.White
	grd.Alignment = Gravity.CENTER 'change to Gravity.LEFT or Gravity.RIGHT for other alignments.	
	grd.Left=Left 
	grd.Top=Top
	grd.Width=Width 
	grd.Height=Height
	grd.ScrollOffset=0   'use scrolling horizontal

	grd.Frame.AddView( grd.Scroll , 0, grd.RowHeight, grd.Width, grd.Height-grd.RowHeight)

	'load columns property	
	grd.colProp=TableColumns.GetTable(Name)	
	
	grd.SelectedRow = -1
	if csvFile<>"" Then
		LoadTableFromCSV(grd,File.DirAssets, csvFile)
	End if
	
	grd.txtEdit.Initialize(name & "_txtEdit")
	grd.txtEdit.Visible=False
	grd.txtEdit.TextSize=fontSize
	grd.txtEdit.InputType=grd.txtEdit.INPUT_TYPE_TEXT
	
	btnLeftImage.Initialize(File.DirAssets,"Leftunselected.png")
	btnRightImage.Initialize(File.DirAssets,"Rightunselected.png")

	grd.btnLeft.SetBackgroundImage(btnLeftImage )
	grd.btnRight.SetBackgroundImage(btnRightImage)

	grd.Frame.AddView( grd.btnLeft , 0,1 , 32, 32)
	grd.Frame.AddView( grd.btnRight , grd.Width-36,1, 32, 32)
	
End Sub

Sub LoadTableFromCSV(grd As Grid, Dir As String, Filename As String)
	ClearGridAll(grd)
	Dim List1 As List
	Dim h() As String

	Dim headers As List
	List1 = StringUtils1.LoadCSV2(Dir, Filename, ",",  headers)
	Dim h(headers.Size) As String
	For i = 0 To headers.Size - 1
		h(i) = headers.Get(i)
	Next

	grd.Cols = h.Length
	grd.Rows=0
	
	SetHeader(grd,h)
	For i = 0 To List1.Size - 1
		Dim row() As String
		row = List1.Get(i)
		AddRow(grd,row)
	Next	
	
End Sub

Sub SaveTableToCSV1(grd As Grid,Dir As String, Filename As String)
	Dim headers(grd.Cols) As String
	
	For i = 0 To headers.Length - 1
		Dim l As Label
		l =grd.Header.GetView(i)
		headers(i) = l.Text
	Next
	Dim list1 As List
	list1.Initialize
	For i = 0 To grd.Rows - 1
		Dim row(grd.Cols) As String
		For c = 0 To grd.Cols - 1
			row(c) = GetCell(grd,i, c)
		Next
		list1.Add(row)
	Next
	StringUtils1.SaveCSV2(Dir, Filename, ",", list1, headers)
End Sub

Sub SelectRow(grd As Grid,Row As Int)
	'remove text edit
	grd.txtEdit.RemoveView
	
	'remove the color of previously selected row
	If grd.SelectedRow > -1 Then
    	For col = 0 To grd.Cols - 1
			GetView(grd.Table,grd.Cols,grd.SelectedRow, Col).Color = grd.CellColor			
		Next
	End If
	grd.SelectedRow = Row
	For col = 0 To grd.Cols - 1
		GetView(grd.Table,grd.Cols,Row, Col).Color = grd.SelectedRowColor
	Next
End Sub


'Returns the label in the specific cell
Sub GetView(pnl As Panel,Cols As Int,Row As Int, Col As Int) As Label
	Dim l As Label	
	l = pnl.GetView(Row * Cols + Col)
	Return l
End Sub

'Adds a row to the Table1
Sub AddRow(grd As Grid, Values() As String)
	Dim sumWidth As Int
	If values.Length <> grd.Cols Then
		Log("Wrong number of values.")
		Return
	End If
	sumWidth=0	
	Dim o As Object
	For i = 0 To grd.Cols - 1
		Select grd.colProp(i).ColType
			Case TableColumns.ColType.Text,TableColumns.ColType.Number,TableColumns.ColType.Combo,TableColumns.ColType.Check,TableColumns.ColType.Date
				Dim l As Label
				l.Initialize(grd.Name & "_Cell")
				l.Text = values(i)		
				'l.Gravity = grd.Alignment
				l.Gravity=grd.colProp(i).Alignment
				if  grd.colProp(i).TextSize=0  Then
					l.TextSize = grd.FontSize
					Else
					l.TextSize = grd.colProp(i).TextSize
				End if
				l.TextColor = grd.FontColor
				l.Color=Colors.White
				Dim rc As RowCol
				rc.Initialize
				rc.Col = i
				rc.Row = grd.Rows
				l.Tag = rc
				l.Visible=grd.colProp(i).Visible
				grd.Table.AddView(l, sumWidth, grd.RowHeight * grd.Rows , grd.colProp(i).Width-grd.ColLineWidth ,grd.RowHeight-grd.RowLineWidth)		
			Case Else
		End Select
		
		sumWidth=sumWidth+grd.colProp(i).Width
	Next
	grd.Table.Width=sumWidth
	grd.Rows = grd.Rows+1
	grd.Table.Height =grd.Rows * grd.RowHeight
End Sub

'Set the headers values
Sub SetHeader(grd As Grid,Values() As String)
	Dim width As Int,sumWidth As Int
	Dim head() As String
	If grd.Header.IsInitialized Then Return 'should only be called once
	grd.Header.Initialize("")
	sumWidth=0

	For i = 0 To Values.Length-1
		Dim l As Label
		l.Initialize(grd.Name&"_Header")
		head = Regex.Split("\|",  values(i))
		'l.Text= head(0)
		l.Text=grd.colProp(i).Text
		'width = head(1)
		
		l.Gravity = Gravity.CENTER
		l.TextSize = grd.FontSize
		l.Color = grd.HeaderColor
		l.TextColor =grd.HeaderFontColor
		l.Tag = i
		l.Visible=grd.colProp(i).Visible
		if l.Visible=False Then grd.colProp(i).Width=0
		width = grd.colProp(i).Width
		grd.Header.AddView(l,  sumWidth, 0, width - grd.ColLineWidth, grd.RowHeight - grd.RowLineWidth)
		sumWidth=sumWidth+width
	Next
	grd.Table.Width = sumWidth
	grd.Frame.AddView(grd.Header,0,0 , grd.Width, grd.RowHeight)	
End Sub

'Sets the value of the given cell
Sub SetCell(grd As Grid,Row As Int, Col As Int, Value As String)
	GetView(grd.Table,grd.Cols,Row, Col).Text = value
End Sub

'Gets the value of the given cell
Sub GetCell(grd As Grid,Row As Int, Col As Int) As String
	Return GetView(grd.Table,grd.Cols,Row, Col).Text
End Sub

'Clears the Table1
Sub ClearGridAll(grd As Grid)
	For i = grd.Table.NumberOfViews -1 To 0 Step -1
		grd.Table.RemoveViewAt(i)
	Next
	grd.Table.Height = 0
End Sub

Sub HeaderLongClick(grd As Grid)
	grd.btnLeft.Visible= Not( grd.btnLeft.Visible)
	grd.btnRight.Visible= Not(grd.btnRight.Visible)
	grd.tmrScrollButtonOff.Enabled=True
End Sub

Sub Table_Scroll(grd As Grid,Left As Boolean)
	if left=True Then 
		'to Left		
		kay=-20 
		if grd.Table.Width+grd.Scroll.Left<=grd.Width Then
			grd.btnLeft.Visible=False
			Return
		End if		
	  Else 
		'to Right
		if grd.Scroll.Left>=0 Then 
			grd.btnRight.Visible=False
			Return
		End if		
		kay=20
	End If
	grd.btnLeft.Visible=True
	grd.btnRight.Visible=True
	grd.ScrollOffset=grd.ScrollOffset+kay
	
	grd.Scroll.Left=grd.ScrollOffset
	grd.Scroll.Width=grd.Scroll.Width-grd.ScrollOffset
	
	grd.Header.Left=grd.ScrollOffset
	grd.Header.Width=grd.Width-grd.ScrollOffset
End Sub
Sub tmrScrollButtonOffTick(grd As Grid)
	grd.btnLeft.Visible=False
	grd.btnRight.Visible=False
	grd.tmrScrollButtonOff.Enabled=False
End Sub
Sub tmrScrollButtonOffEnabled(grd As Grid)
	grd.tmrScrollButtonOff.Enabled=False
	grd.tmrScrollButtonOff.Enabled=True
	
End Sub

Sub EditTextOpen(grd As Grid, s As Label)

	Dim rc As RowCol
	Dim l As Label : l = s 'Sender
	rc = l.Tag
	Dim r As Int	
	
	if grd.colProp(rc.Col).Readonly=True Then Return
	
	Select grd.colProp(rc.Col).ColType
		Case TableColumns.ColType.Text,TableColumns.ColType.Number
			grd.txtEdit.RemoveView
			grd.Table.AddView(grd.txtEdit,l.Left-5,l.Top-5,l.Width+10,l.Height+15)
			grd.Col=rc.Col
			grd.Row=rc.Row
			grd.txtEdit.Text=l.Text
			if grd.colProp(rc.Col).ColType=TableColumns.ColType.Number Then
				grd.txtEdit.InputType=grd.txtEdit.INPUT_TYPE_NUMBERS
			End if
			grd.txtEdit.RequestFocus
			grd.txtEdit.ForceDoneButton=True
			grd.txtEdit.Visible=True
		Case TableColumns.ColType.Combo
			r=InputList(grd.colProp(rc.Col).Lookup, "Seçiniz",rc.Key) 
			if r<>-3 Then
				rc.Key=r
				l.Text=grd.colProp(rc.Col).Lookup.Get(r)				
			End if
		Case TableColumns.ColType.Check
			if l.Text="x" Then
				l.Text=""
				 Else
				l.Text="x"
			End if
		Case TableColumns.ColType.Date
			Dim Dd As DateDialog
			' set the date shown when the dialog is openend
			Dd.DateTicks = DateTime.Now	
			ret = Dd.Show("Please choose a date", "Date-Chooser", "OK", "", "Cancel", Null)
			If ret = DialogResponse.CANCEL Then Return
			l.Text = DateTime.Date(Dd.DateTicks)
		Case Else
	End Select
End Sub


Sub txtEditEnterPressed(grd As Grid,e As EditText)	

	Dim L As Label
	L=grd.Table.GetView(grd.Row*grd.Cols+grd.Col)
	L.Text=e.Text
	grd.txtEdit.RemoveView
End Sub

Sub txtEditFocusChanged(grd As Grid, HasFocus As Boolean)

End Sub